using System;
using System.Threading.Tasks;
using Dicom.Network;
using Grpc.Core;
using Microsoft.Extensions.Logging;
using DicomClient = Dicom.Network.Client.DicomClient;

namespace ExchangeService.GrpcServer
{
    public class DicomFileOperationService : DicomOps.DicomOpsBase
    {
        private readonly ILogger _logger;
        public DicomFileOperationService(ILoggerFactory loggerFactory)
        {
            _logger = loggerFactory.CreateLogger<DicomFileOperationService>();
        }

        public override async Task TransferDicomFiles(DicomFilesTransferModel request,
            IServerStreamWriter<DicomFilesTransferResponse> responseStream,
            ServerCallContext context)
        {
            var client = new DicomClient("127.0.0.1", 104, false, "MARCO", "ANY-SCP");
            //var client = new DicomClient(request.ServerHost, request.Port, false, request.ServerAET, request.Aet);
            client.NegotiateAsyncOps();

            try
            {
                var requests = new DicomCStoreRequest(request.UploadedFile);
                await client.AddRequestAsync(requests);
                await client.SendAsync();
                await responseStream.WriteAsync(new DicomFilesTransferResponse() { Message = $" {request.UploadedFile}  file Send" });
            }
            catch (Exception ex)
            {
                await responseStream.WriteAsync(new DicomFilesTransferResponse() { Message = ex.Message });
            }
        }
    }
}
